Problem A: Bird

2024-03-27 04:58
文章标签 bird problem

本文主要是介绍Problem A: Bird,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

这里写图片描述这里写图片描述
考虑到集训篇题目有点少。
我再写两篇QAQ

emmm一开始没有想法,甚至连暴力都不知道…最后交了一个40分傻逼费用流…

正解:首先肯定能发现如果对于一条边,正着跑了一次,反着跑了一次,那么这两次其实可以抵消掉(实际就费用流的思想) 考虑到树高实际只有log,那么用f[i]表示i的子树到i的最小花费,那么模拟费用流,在x的所有祖先上求一次min(f[x])
就可以得到应该在哪个点的子树取到最小值,然后暴力更改即可

c++代码如下:

#include<bits/stdc++.h>
#define rep(i,x,y) for(register int i = x; i <= y; ++ i)
#define repd(i,x,y) for(register int i = x ; i >= y; -- i)
using namespace std;
typedef long long ll;
inline char gc(){static char now[1<<16],*S,*T;if (T==S){T=(S=now)+fread(now,1,1<<16,stdin);if (T==S) return EOF;}return *S++;
}
template<typename T>inline void read(T&x)
{x = 0;char c;int sign = 1;do { c = gc(); if(c == '-') sign = 1; }while(!isdigit(c));do { x = x * 10 + c - '0'; c = gc(); }while(isdigit(c));x *= sign;
}
const int OUT_LEN = 1024 * 1024;
char obuf[OUT_LEN], *oh = obuf;
inline void write_char(char c) {if (oh == obuf + OUT_LEN) fwrite(obuf, 1, OUT_LEN, stdout), oh = obuf;*oh++ = c;
}template<class T>
inline void W(T x) {static int buf[30], cnt;if (x == 0) write_char('0');else {if (x < 0) write_char('-'), x = -x;for (cnt = 0; x; x /= 10) buf[++cnt] = x % 10 + 48;while (cnt) write_char(buf[cnt--]);}
}inline void flush() {fwrite(obuf, 1, oh - obuf, stdout);
}const int N = 6e5 + 50;
int n,m,f[N],c[N],p[N];
int mark1[N],mark2[N];void dfs(int x)
{if(x > n) return ;f[x] = 0x3f3f3f3f;if(c[x]) f[x] = 0;dfs(x << 1); dfs(x << 1|1);f[x] = min(f[x],min(f[x << 1] + 1,f[x << 1|1] + 1));
}void update(int x)
{if(!x) return;f[x] = 0x3f3f3f3f;if(c[x]) f[x] = 0;f[x] = min(f[x],min(f[x << 1] + (mark1[x << 1] > 0 ? -1 : 1),f[x << 1|1] + (mark1[x << 1|1] > 0 ? -1 : 1)));update(x >> 1);
}int solve(int x)
{int k = f[x],num = 0x3f3f3f3f,y = x,p = 0,ans = 0;while(x){if(f[x] + p < num) k = x,num = f[x] + p;if(mark2[x]) --p; else ++p;x = x >> 1;}x = y;while(x != k){if(mark2[x]) -- mark2[x],-- ans;else ++mark1[x],++ ans;x = x >> 1;}if(c[x]) { --c[x]; update(y); return ans; }while(!c[x]){if(f[x << 1] + (mark1[x << 1] > 0 ? -1 : 1) < f[x << 1|1] + (mark1[x << 1|1] > 0 ? -1 : 1)){if(mark1[x << 1] > 0) --mark1[x << 1], -- ans;else ++mark2[x << 1],++ans;x = x << 1;}else{if(mark1[x << 1|1] > 0) --mark1[x << 1|1], -- ans;else ++mark2[x << 1|1],++ans;x = x << 1|1;}}-- c[x];update(y); update(x);return ans;
}int main()
{memset(f,0x3f,sizeof f);read(n); read(m);rep(i,1,n) read(c[i]);rep(i,1,m) read(p[i]);dfs(1);int ans = 0;rep(i,1,m){ans += solve(p[i]);printf("%d ",ans);}flush();return 0;
}

这篇关于Problem A: Bird的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/851005

相关文章

csu 1446 Problem J Modified LCS (扩展欧几里得算法的简单应用)

这是一道扩展欧几里得算法的简单应用题,这题是在湖南多校训练赛中队友ac的一道题,在比赛之后请教了队友,然后自己把它a掉 这也是自己独自做扩展欧几里得算法的题目 题意:把题意转变下就变成了:求d1*x - d2*y = f2 - f1的解,很明显用exgcd来解 下面介绍一下exgcd的一些知识点:求ax + by = c的解 一、首先求ax + by = gcd(a,b)的解 这个

uva 10025 The ? 1 ? 2 ? ... ? n = k problem(数学)

题意是    ?  1  ?  2  ?  ...  ?  n = k 式子中给k,? 处可以填 + 也可以填 - ,问最小满足条件的n。 e.g k = 12  - 1 + 2 + 3 + 4 + 5 + 6 - 7 = 12 with n = 7。 先给证明,令 S(n) = 1 + 2 + 3 + 4 + 5 + .... + n 暴搜n,搜出当 S(n) >=

11991 - Easy Problem from Rujia Liu?

题意: 输入一串整型数列,再输入两个数k,v,输出第k个v的序号。不存在则输出0,如第一个样例 8 41 3 2 2 4 3 2 11 3 //第1个3,序号为2,输出22 4 //第2个4,不存在,输出03 2 //第3个2,序号为7,输出74 2 思路: struct num {

HDU 1016 Prime Ring Problem (深搜)

OJ题目 : click here ~~ 大概题意:n个数,形成一个环,使得相邻两个数的和为素数。以1开始,按字典序输出序列。 很简单的深搜。 AC_CODE int n;int visit[22];int num[22];int len;bool Is_prime(int x){for(int i = 2;i*i <= x;i++)if(x%i == 0) return

LVM 'Can’t open /dev/sdb1 exclusively. Mounted filesystem?' Problem

在将几块盘做LVM时,遇到一个之前都没遇到过的问题: root@ubuntu:~# pvcreate /dev/sdc1Can't open /dev/sdc1 exclusively. Mounted filesystem? 首先第一反应就是查看这个分区是否已经在使用了,但是没有。 查看硬盘的一些信息: root@ubuntu:~# cat /proc/partitionsmajo

【HDU】3861 The King’s Problem 强连通缩点+有向图最小路径覆盖

传送门:【HDU】3861 The King’s Problem 题目分析:首先强连通缩点,因为形成一个环的王国肯定在一条路径中,这样才能保证拆的少。 然后缩点后就是DAG图了,由于题目要求的是最小路径覆盖,那么二分匹配即可。 代码如下: #include <cstdio>#include <cstring>#include <algorithm>#includ

【ZOJ】3362 Beer Problem 最小费用流

传送门:【ZOJ】3362 Beer Problem 题目分析:这道题本来应该很快就AC的,但是!因为我以前犯的一个致命错误导致我这题一天了到现在才调出来!唉。。失策。。貌似给的模板也有这个错误。。。马上就去改。。但是这个错误竟然还能过掉那么多的题。。害我还要一题一题的改回去。。 本题就是赤裸裸的最小费用流。 新建汇点t(源点即1),将所有的n-1个城市和汇点建边,容量为无穷大,

【HDU】4975 A simple Gaussian elimination problem. 网络流——行列建边

传送门:【HDU】4975 A simple Gaussian elimination problem. 题目分析:这题和某一场的多校的题目出奇的像啊!重要的是我一开始还以为不可能会出一样的题。。结果迟迟没写啊。。。后来觉得实在想不出什么对策了,虽然觉得给的是0~9很特殊,但是利用不起来,果断还是敲了网络流了。。首先建图很简单,源点向行建边,容量为行和,列向汇点建边,容量为列和,然后所有的

Splay树(区间更新)—— POJ 3468 A Simple Problem with Integers

对应POJ 题目:点击打开链接 A Simple Problem with Integers Time Limit: 5000MS Memory Limit: 131072KTotal Submissions: 72765 Accepted: 22465Case Time Limit: 2000MS Description You have N integers, A1

系统设计:Top K Problem (Heavy Hitters)

System Design Interview - Top K Problem (Heavy Hitters) https://www.youtube.com/watch?v=kx-XDoPjoHw&t=1068s